Procedure myWindowCallback(hwnd, message, wParam, lParam) 
Protected result = #PB_ProcessPureBasicEvents 
Protected *nmhdr.NMHDR, *nmlv.NM_LISTVIEW
Static subitem

;#LVN_HOTTRACK = -121
;#LVN_ITEMCHANGED = -101
;#LVN_ITEMCHANGING = -100

If message = #WM_NOTIFY 

   *nmhdr.NMHDR = lParam 
   If *nmhdr\hwndFrom = pv\mainlvid 
      *nmlv.NM_LISTVIEW = lParam    
      If *nmlv\hdr\code = #LVN_HOTTRACK  
         subitem = *nmlv\iSubItem
         pv\lvinfo = GetGadgetItemText(#main_liste, *nmlv\iItem, subItem)
         StatusBarText(0, 2, pv\lvinfo)
      ElseIf *nmlv\hdr\code = #LVN_ITEMCHANGING
         pv\lvinfo = GetGadgetItemText(#main_liste, *nmlv\iItem, subItem)
         StatusBarText(0, 2, pv\lvinfo)
      EndIf         
   EndIf 

EndIf 

ProcedureReturn result 
EndProcedure 

Procedure.i SetMenuBackColor()
   
If pv\menubackbrush: DeleteObject_(pv\menubackbrush): EndIf
pv\menubackbrush = CreateSolidBrush_(pv\menubackcolor)

; Protected br = 100
; Protected hh = 50  ;MenuHeight() + 30, erst ab 30 nimmt menu das Bild
; Protected nr = CreateImage(#PB_Any, br, hh) 
; StartDrawing(ImageOutput(nr))
;   DrawingMode(#PB_2DDrawing_Gradient)      
;   BackColor(#White)
;   FrontColor(#Green)
;   LinearGradient(hh, 0, hh, hh)          
;   LinearGradient(hh, 25, hh, hh + hh/2)  ;um 25-30 nach unten schieben        
;   Box(0, 0, br, hh)
; StopDrawing()
; 
; pv\menubackbrush = CreatePatternBrush_(ImageID(nr))
;   
; SaveImage(nr, "menu.bmp", #PB_ImagePlugin_BMP, 0, 8)     
; OpenWindow(999,0,0,111,66,"")
; ImageGadget(999,0,0,0,0,ImageID(nr))
; SetActiveWindow(#main_window)
; FreeImage(nr)

#MIM_BACKGROUND = 2
#MIM_APPLYTOSUBMENUS = $80000000

Structure myMENUINFO
  cbSize.i
  fMask.i
  dwStyle.i
  cyMax.i
  hbrBack.i
  dwContextHelpId.i
  dwMenuData.i
EndStructure

Protected mi.myMENUINFO

With mi.myMENUINFO
  \cbSize = SizeOf(myMENUINFO)
  \fMask = #MIM_BACKGROUND | #MIM_APPLYTOSUBMENUS
  \hbrBack = pv\menubackbrush
EndWith

SetMenuInfo_(pv\menuid, mi)
DrawMenuBar_(WindowID(#main_window)) 

EndProcedure

Procedure.i SetWindowDateiInfo()
   
SetWindowTitle(#main_window, pv\version1 + GetFilePart(pv\dateiname)) 

StatusBarText(0, 0, pv\dateiname)

If IsGadget(#main_liste)
   StatusBarText(0, 1, Str(CountGadgetItems(#main_liste)))
EndIf
   
EndProcedure

Procedure.i ProgrammIni()
Protected j

With pv.myProgrammvariablen
   
   \inidatei = "MiniAdr.ini"
   \version1 = "MiniAdr V4.10 - "
   \version2 = FormatDate("%mm%dd - %hh%ii ", Date())
   \version2 + "(PB 4.5 x86) by HJBremer"

   ExamineDesktops()
   \desktopbreite = DesktopWidth(0)
   \desktophoehe = DesktopHeight(0) 
   \buttonbr = 99
   \buttonhh = 22 
   \subwinbrhh = 450
   \maxcolbreite = 180  ;siehe auch FormatIniFile()
   
   \lastenumeration = #PB_Compiler_EnumerationValue
   
   For j = 0 To #maxfelder
      \lastenumeration + 1
      \eingabepbnr[j] = \lastenumeration 
   Next

   For j = 0 To #lastfilesmax  
      \lastenumeration + 1
      \lastmenunr[j] = \lastenumeration
   Next  

EndWith
EndProcedure

Procedure.i ProgrammIniFile(flag)
Protected j, ok

With pv.myProgrammvariablen   

  ok = OpenPreferences(\inidatei)
  If Not ok: CreatePreferences(\inidatei): EndIf

  If flag = #write
     
     PreferenceGroup("MainWindow")
         WritePreferenceInteger("Windowbreite", \windowbreite)
         WritePreferenceInteger("Windowhoehe", \windowhoehe)
     PreferenceGroup("LastFiles")
         For j = 0 To #lastfilesmax
           WritePreferenceString ("File"+Str(j), \lastfiles[j])
         Next
     PreferenceGroup("Font")
         WritePreferenceString ("FontnameListe",   \lvfontname)
         WritePreferenceInteger("FonthoeheListe",  \lvfonthoehe)
         WritePreferenceString ("FontnameButton",  \bufontname)
         WritePreferenceInteger("FonthoeheButton", \bufonthoehe)
     PreferenceGroup("Colors")
         WritePreferenceInteger("LineColor",  \lvlinecolor)
         WritePreferenceInteger("BackColor",  \lvbackcolor)
         WritePreferenceInteger("FrontColor", \lvtextcolor)
         WritePreferenceInteger("LineColor1", \lvlinecolor1)
         WritePreferenceInteger("MenuColorBg",\menubackcolor)
     PreferenceGroup("Suchen") 
         WritePreferenceInteger("GrossKlein", \suchgrossklein)
         WritePreferenceInteger("AusinListe", \suchAusgabeinLv)
     PreferenceGroup("Diverses")
         WritePreferenceString ("StartDatei",  \startdateiname) 
         WritePreferenceInteger("Saveflag",    \autosaveflag)
         WritePreferenceInteger("Startflag",   \autostartflag)
         WritePreferenceInteger("Headertheme", \headertheme)  
         WritePreferenceInteger("Formatflag",  \formatflag)  
         WritePreferenceInteger("SortCaseGK",  \sortcasegk)  
         WritePreferenceInteger("Sortspalte1", \sortspalte[1])  
         WritePreferenceInteger("Sortspalte2", \sortspalte[2])  
         WritePreferenceInteger("Sortspalte3", \sortspalte[3])  
         
  ElseIf flag = #read
     
     PreferenceGroup("MainWindow")
         \windowbreite = ReadPreferenceInteger("Windowbreite", 650)
         \windowhoehe = ReadPreferenceInteger("Windowhoehe", 500)
     PreferenceGroup("LastFiles")
         For j = 0 To #lastfilesmax
            \lastfiles[j] = ReadPreferenceString ("File"+Str(j), "")
         Next
     PreferenceGroup("Font")
         \lvfontname = ReadPreferenceString ("FontnameListe", "Arial")
         \lvfonthoehe = ReadPreferenceInteger("FonthoeheListe", 9)
         \bufontname = ReadPreferenceString ("FontnameButton", "Arial")
         \bufonthoehe = ReadPreferenceInteger("FonthoeheButton", 9)
     PreferenceGroup("Colors")
         \lvlinecolor = ReadPreferenceInteger("LineColor", #Gray)
         \lvbackcolor = ReadPreferenceInteger("BackColor", #White)
         \lvtextcolor = ReadPreferenceInteger("FrontColor", #Blue)
         \lvlinecolor1 = ReadPreferenceInteger("LineColor1", #Magenta)
         \menubackcolor = ReadPreferenceInteger("MenuColorBg", $DDF9CE)
     PreferenceGroup("Suchen") 
         \suchgrossklein = ReadPreferenceInteger("GrossKlein", 0)
         \suchAusgabeinLv = ReadPreferenceInteger("AusinListe", 0)
     PreferenceGroup("Diverses")
         \startdateiname = ReadPreferenceString ("StartDatei", "miniadress.txt") 
         \autosaveflag   = ReadPreferenceInteger("Saveflag", 0)
         \autostartflag  = ReadPreferenceInteger("Startflag", 0)
         \headertheme    = ReadPreferenceInteger("Headertheme", 0)    
         \formatflag     = ReadPreferenceInteger("Formatflag", 0)    
         \sortcasegk     = ReadPreferenceInteger("SortCaseGK", 0)  
         \sortspalte[1]  = ReadPreferenceInteger("Sortspalte1", 1)  
         \sortspalte[2]  = ReadPreferenceInteger("Sortspalte2", 2)  
         \sortspalte[3]  = ReadPreferenceInteger("Sortspalte3", 3)  
                  
  EndIf
  ClosePreferences()
  
EndWith
EndProcedure

Procedure.i CreateMainWindow()

   Protected flag = #PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered
             flag | #PB_Window_SizeGadget

OpenWindow(#main_window, 0, 0, pv\windowbreite, pv\windowhoehe, pv\version1, flag) 
    
CreateStatusBar(0, WindowID(#main_window))
   AddStatusBarField(#PB_Ignore)
   AddStatusBarField(40)
   AddStatusBarField(#PB_Ignore)
      
AddKeyboardShortcut(#main_window, #PB_Shortcut_Control|#PB_Shortcut_O , #menu_load)
AddKeyboardShortcut(#main_window, #PB_Shortcut_Control|#PB_Shortcut_S , #menu_save)
AddKeyboardShortcut(#main_window, #PB_Shortcut_Alt    |#PB_Shortcut_F4, #menu_progende)
AddKeyboardShortcut(#main_window, #PB_Shortcut_Control|#PB_Shortcut_N , #menu_neu)
AddKeyboardShortcut(#main_window, #PB_Shortcut_Control|#PB_Shortcut_F , #menu_suchenNormal)
AddKeyboardShortcut(#main_window,                      #PB_Shortcut_F4, #menu_suchenNormal)
AddKeyboardShortcut(#main_window,                      #PB_Shortcut_F3, #menu_suchenWeiter)

EndProcedure

Procedure.i CreateCalenderWindow()
Protected flags = #PB_Window_Tool | #PB_Window_ScreenCentered
Protected br = 220, hh = 230

flags | #PB_Window_Invisible

OpenWindow(#calendar_window, 0, 0, br, hh, "Kalender", flags)
Frame3DGadget(#PB_Any, 1, 1, br - 2, hh - 2, "", #PB_Frame3D_Double)
CalendarGadget(#calendar_gadget, 10, 10, br - 20, hh - 50)
ButtonGadget(#calendar_button, (br - 60) / 2, hh - 30, 60, 20, "ok")

;#calendar_button wird in MiniAdr-Daten.pbi / Daten_Events abgefragt

EndProcedure

Procedure.i CreateProgrammMenu(flag = 0)
Protected j
   
If IsMenu(0): FreeMenu(0): EndIf
pv\menuid = CreateMenu(0, WindowID(#main_window)) 

If flag
   MenuTitle("&Datei")
     MenuItem( #menu_new,  "&Neu")
     MenuItem( #menu_load, "&ffnen" + #TAB$ + "Strg+O")
     MenuItem( #menu_save, "&Speichern" + #TAB$ + "Strg+S")
     MenuItem( #menu_save1, "Speichern &als...")
     MenuBar()
     MenuItem( #menu_load1, "&ffnen ohne Titel/Spaltennamen")
     MenuBar()
     MenuItem( #menu_option, "&Einstellungen")
     MenuItem( #menu_drucken, "&Drucken")
     MenuBar()
     OpenSubMenu("&Letzte Dateien")
       For j = 0 To #lastfilesmax
         MenuItem( pv\lastmenunr[j], "")
       Next
     CloseSubMenu()                    
     MenuBar()
     MenuItem( #menu_progende, "&Beenden" + #TAB$ + "Alt+F4")
   MenuTitle("&Bearbeiten")
     MenuItem( #menu_neu, "&Neu" + #TAB$ + "Strg+N")
     MenuItem( #menu_edit, "&ndern")
     MenuItem( #menu_kill,"&Lschen")
   MenuTitle("&Suchen")
     MenuItem( #menu_suchenNormal, "&Suchen" + #TAB$ + "Strg+F / F4")
     MenuItem( #menu_suchenImFeld, "Suchen im &Feld")
     MenuItem( #menu_suchenWeiter, "&Weitersuchen" + #TAB$ + "F3")
   MenuTitle("S&ortieren")
     MenuItem( #menu_sortieren, "S&ortieren")
   MenuTitle("S&palten")
     MenuItem( #menu_spaltenName, "Spaltennamen &ndern")
     MenuItem( #menu_spalteEntfernen, "Spalte &entfernen")
     MenuItem( #menu_spalteAnhaengen, "Spalte &anhngen")
     MenuBar()
     MenuItem( #menu_spaltenInfo, "Spalten &Reihenfolge")
   MenuTitle("Di&verses")
     MenuItem( #menu_versionsinfo, pv\version1 + pv\version2)    
     MenuBar()
     MenuItem( #menu_divDateGadget, "&Kalender aufrufen")    
     MenuItem( #menu_divSumme,      "&Summe ermitteln")  
     MenuBar()
     MenuItem( #menu_divNotepadFmt, "&Format Datei bearbeiten")    
     MenuItem( #menu_divNotepadPop, "&PopUp Datei bearbeiten")  
          
Else
   MenuTitle("&Datei")
     MenuItem( #menu_new,  "&Neu")
     MenuItem( #menu_load, "&ffnen" + #TAB$ + "Strg+O")
     MenuBar()
     MenuItem( #menu_progende, "&Beenden" + #TAB$ + "Alt+F4") 
EndIf

SetMenuBackColor()

EndProcedure

; -Allgemeine Procs, benutzt Konstanten und globale Struktur

Procedure.i Infomeldung(titelnr = 0, info$ = "", flag = 0)
Protected titel$, icon, antwort

Select titelnr
   Case 0: titel$ = "?":       icon = #MB_ICONASTERISK     ;64 
   Case 1: titel$ = "Info":    icon = #MB_ICONASTERISK     ;64
   Case 2: titel$ = "Hinweis": icon = #MB_ICONEXCLAMATION  ;48
   Case 3: titel$ = "Warnung": icon = #MB_ICONQUESTION     ;32
   Case 4: titel$ = "Error":   icon = #MB_ICONSTOP         ;16
EndSelect  

antwort = MessageRequester(titel$, info$, flag | icon)

ProcedureReturn antwort
EndProcedure

Procedure.i GetTextBreite(txt$, id) 
Protected br

StartDrawing(WindowOutput(#main_window))
   DrawingFont(id)
   br = TextWidth(txt$)
StopDrawing()

ProcedureReturn br
EndProcedure 

Procedure.i GetTextHoehe(txt$, id) 
Protected hh

StartDrawing(WindowOutput(#main_window))
   DrawingFont(id)
   hh = TextHeight(txt$)
StopDrawing()

ProcedureReturn hh
EndProcedure 

Procedure.i ListeAutosize(pbnr)
Protected j, breite
If IsGadget(pbnr)
   HideGadget(pbnr,1) 
   For j = 1 To pv\feldanzahl
      ;Breite setzen, so das nichts abgeschnitten wird
      SendMessage_(GadgetID(pbnr), #LVM_SETCOLUMNWIDTH, j, #LVSCW_AUTOSIZE_USEHEADER)
      breite = GetGadgetItemAttribute(pbnr, 0, #PB_ListIcon_ColumnWidth, j)
      ;ist in der Formatdatei eine Breite definiert ?
      If pv\feldfixbreite[j]
         SetGadgetItemAttribute(pbnr, 0, #PB_ListIcon_ColumnWidth, pv\feldfixbreite[j], j) 
      ElseIf breite > pv\maxcolbreite   ;Breite begrenzen
         SetGadgetItemAttribute(pbnr, 0, #PB_ListIcon_ColumnWidth, pv\maxcolbreite, j)
      EndIf
   Next
   HideGadget(pbnr,0)
EndIf  
EndProcedure

Procedure.i ListeResize(pbnr)
   pv\windowbreite = WindowWidth(#main_window)
   pv\windowhoehe = WindowHeight(#main_window)
   If IsGadget(pbnr) 
      If pbnr = #main_liste
         ResizeGadget(pbnr, #PB_Ignore, #PB_Ignore, pv\windowbreite, pv\windowhoehe-44) 
         ListeAutosize(pbnr)             
      ElseIf pbnr = #suchliste
         ResizeWindow(#sub_window, 15 + WindowX(#main_window), #PB_Ignore, pv\windowbreite-30, #PB_Ignore)
         ResizeGadget(pbnr, #PB_Ignore, #PB_Ignore, pv\windowbreite-30, #PB_Ignore) 
         ListeAutosize(pbnr)             
      EndIf
  EndIf            
EndProcedure

Procedure.i SetColorAndFont()
Static oldfonthoehe, oldfontname$

With pv.myProgrammvariablen   

  SetGadgetColor(#main_liste, #PB_Gadget_LineColor, \lvlinecolor)
  SetGadgetColor(#main_liste, #PB_Gadget_BackColor, \lvbackcolor)
  SetGadgetColor(#main_liste, #PB_Gadget_FrontColor, \lvtextcolor)
  
  If \bufonthoehe <> oldfonthoehe Or \bufontname <> oldfontname$
     oldfonthoehe = \bufonthoehe
     oldfontname$ = \bufontname
     LoadFont(#fontnrButton, \bufontname, \bufonthoehe)
     SetGadgetFont(#PB_Default, FontID(#fontnrButton))
     \buttonhh = GetTextHoehe("y", FontID(#fontnrButton)) + 6
     If \buttonhh > #button_abstand: \buttonhh = #button_abstand - 2: EndIf
  EndIf
  
  If \lvfonthoehe
     LoadFont(#fontnrListe, \lvfontname, \lvfonthoehe)
     SetGadgetFont(#main_liste, FontID(#fontnrListe))
  EndIf
  
  Protected null
  If \headertheme: SetWindowTheme_(\headerid, @null, @null): EndIf
  
EndWith
EndProcedure

Procedure.i ColorRequester1(*farbe.integer)

Protected farbeneu = ColorRequester(*farbe\i)

If farbeneu > -1
   *farbe\i = farbeneu
   SetColorAndFont()
   SetMenuBackColor()
EndIf

EndProcedure

Procedure.i SpaltenNameOk(pbnr, name$)
Protected j 
Protected fbanz = CountGadgetItems(pbnr)

For j = 0 To fbanz - 1
    If name$ = Trim(GetGadgetItemText(pbnr, j))
       Infomeldung(1, "Name bereits vorhanden")
       ProcedureReturn 0
    EndIf   
Next

ProcedureReturn 1
EndProcedure

Procedure.i LastFilesUpdateMenu()
Protected j, menutext$

For j = 0 To #lastfilesmax
   menutext$ = Str(j) + ")  " + pv\lastfiles[j]
   SetMenuItemText(0, pv\lastmenunr[j], menutext$)
   DisableMenuItem(0, pv\lastmenunr[j], 0)
   If Not Trim(pv\lastfiles[j])
      DisableMenuItem(0, pv\lastmenunr[j], 1)
   EndIf 
Next

EndProcedure
Procedure.i LastFilesSave(dat$)
Protected posi, j

  ;schon vorhanden ?
  posi = #lastfilesmax
  For j = 0 To #lastfilesmax
    If dat$ = pv\lastfiles[j]: posi = j: Break: EndIf
  Next
  
  ;schieben
  For j = posi To 1 Step -1
    pv\lastfiles[j] = pv\lastfiles[j-1]
  Next
  pv\lastfiles[0] = dat$

  ProgrammIniFile(#write)     ;speichern
  LastFilesUpdateMenu() 

EndProcedure

Procedure.i CreateListIconGadget()
Protected j, flag, lvid
Protected hh = pv\windowhoehe - MenuHeight() - StatusBarHeight(0)

  UseGadgetList(WindowID(#main_window))   

  flag = #PB_ListIcon_HeaderDragDrop|#PB_ListIcon_GridLines|#PB_ListIcon_FullRowSelect
  flag | #PB_ListIcon_AlwaysShowSelection
  flag | #PB_ListIcon_MultiSelect 
  lvid = ListIconGadget(#main_liste, 0, 0, pv\windowbreite, hh, "Leer", 0, flag)

  pv\mainlvid = lvid
  pv\headerid = SendMessage_(lvid, #LVM_GETHEADER, 0, 0) 
  
  For j = 1 To pv\feldanzahl
    AddGadgetColumn (#main_liste, j, pv\feldnamen[j], 1) 
  Next
  
  Protected exstyle = SendMessage_(lvid, #LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0)
  SendMessage_(lvid, #LVM_SETEXTENDEDLISTVIEWSTYLE, 0, exstyle | #LVS_EX_LABELTIP) 
 
  CreateProgrammMenu(1)
  LastFilesUpdateMenu()
  SetColorAndFont()  
  
EndProcedure

Procedure.i SubWindowOpen(titel$, close$ = "Ende")
Protected x = 90 + WindowX(#main_window) 
Protected y = 30 + WindowY(#main_window) 
Protected z = pv\subwinbrhh
Protected b = pv\buttonbr + (pv\buttonbr / 2) ;Breite der 2 linken Buttons
Protected a = (z - pv\buttonbr - b - b - 10) / 2   ;Abstand dazwischen
 
  DisableWindow(#main_window, 1)
  OpenWindow(#sub_window, x, y, z, z, "  " + titel$, #PB_Window_Tool, WindowID(#main_window)) 
  AddKeyboardShortcut(#sub_window, #PB_Shortcut_Escape, #eingabe_ende)
 
  ;SetGadgetFont(#PB_Default, FontID(#fontnrButton))
 
   y = z - pv\buttonhh - 11: pv\subwinlastrow = y
   x = 5
   ButtonGadget(#eingabe_links, x, y, b, pv\buttonhh, "")
   x + a + b  
   ButtonGadget(#eingabe_start, x, y, b, pv\buttonhh, "")   
   x = z - pv\buttonbr - 5  
   ButtonGadget(#eingabe_ende,  x, y, pv\buttonbr, pv\buttonhh, close$)
     
EndProcedure

Procedure.i SubWindowClose()
  pv\progflag = 0
  DisableWindow(#main_window, 0)
  CloseWindow(#sub_window)
EndProcedure

Procedure.s GetOrderArray()
Protected ok, j, x$

With pv.myProgrammvariablen 

  If Not \feldanzahl: InfoMeldung(): ProcedureReturn: EndIf
  
  ok = SendMessage_(GadgetID(#main_liste), #LVM_GETCOLUMNORDERARRAY, \feldanzahl+1, @\OrderArray[0]) 
  If ok
     For j = 0 To \feldanzahl 
       x$ + Str(\OrderArray[j]) + ","
       ;Debug GetGadgetItemText(#main_liste, -1, \OrderArray[j])
     Next 
  EndIf

EndWith

ProcedureReturn x$  
EndProcedure
Procedure.s Datensatzholen(item, flag = 0)
;wenn flag gesetzt, holt einen Datensatz mit dem OrderArray 
;um ihn in der optischen Reihenfolge zu speichern  

Protected j, k, x$ = "" 

  For j = 1 To pv\feldanzahl
    k = j
    If flag: k = pv\orderarray[j]: EndIf
    x$ + GetGadgetItemText(#main_liste, item, k) + #LF$
  Next
  ;Debug x$
ProcedureReturn x$
EndProcedure
Procedure.i VergleicheSatz(q$, s$)
Protected j, qitem$, sitem$, ok = -1

For j = 1 To pv\feldanzahl  
    qitem$ = StringField(q$, j, #LF$)  
    sitem$ = StringField(s$, j, #LF$)  
    If sitem$
       Select pv\suchart     ;wird in EingabeOk() gesetzt
          Case #suchart1     ;alle Eingaben enthalten
               If FindString(qitem$, sitem$, 1)
                  ok = 1
               Else
                  ok = -1: Break   
               EndIf    
       EndSelect
    EndIf
Next

ProcedureReturn ok    
EndProcedure

Procedure.i GetFeldEingabeIndex(wB)
Protected j, nr = 0

For j = 1 To pv\feldanzahl 
   If pv\eingabepbnr[j] = wB
      nr = j: Break
   EndIf
Next

ProcedureReturn nr
EndProcedure

; IDE Options = PureBasic 4.50 RC 2 (Windows - x86)
; CursorPosition = 293
; FirstLine = 281
; Folding = -nhn-
; EnableXP