
Procedure.i EingabeFensterNamebreite(von,bis)
Protected j, x, breite = 0

  For j = von To bis      
      x = Gettextbreite(pv\feldnamen[j], FontID(#fontnrButton))
      If x > breite: breite = x: EndIf     
  Next
  
ProcedureReturn breite 
EndProcedure

Procedure.i EingabeFensterFeldbreite(von, bis)
Protected j, x, breite = 0

  For j = von To bis      
      x = GetGadgetItemAttribute(#main_liste, 0, #PB_ListIcon_ColumnWidth, j)
      If x < 99: x = 99: EndIf
      If x > pv\maxcolbreite: x = pv\maxcolbreite: EndIf       
      pv\feldbreite[j] = x 
      If x > breite: breite = x: EndIf     
  Next

ProcedureReturn breite
EndProcedure

Procedure.i EingabeFensterWriteFeld(von, bis, x1, textbr, vorgabe$)
Protected y = 10
Protected x2 = x1 + textbr + 10
Protected k, x$

  For k = von To bis      
      TextGadget(#PB_Any, x1, y, textbr, pv\buttonhh, pv\feldnamen[k], #PB_Text_Right|#SS_ENDELLIPSIS)
      x$ = StringField(vorgabe$, k + 0, #LF$)
      StringGadget(pv\eingabepbnr[k], x2, y, pv\feldbreite[k], pv\buttonhh, x$)  
      y + #button_abstand
  Next

EndProcedure

Procedure.i EingabeFenster(info$, vorgabe$)
Protected x, y, j, von, bis, startinfo$
Protected namebrmax, feldbrmax, subwindowbreite

With pv.myProgrammvariablen  

If Not \feldanzahl: InfoMeldung(): ProcedureReturn: EndIf

  SubWindowOpen(info$, "Abbruch")  
  AddKeyboardShortcut(#sub_window, #PB_Shortcut_Return, #eingabe_Return) 
   
  #anzahlsenkrecht = 10 
  x = 0
  For j = 1 To \feldanzahl Step #anzahlsenkrecht
      von = j: bis = von - 1 + #anzahlsenkrecht
      If bis > \feldanzahl: bis = \feldanzahl: EndIf
      namebrmax = EingabeFensterNamebreite(von, bis)
      feldbrmax = EingabeFensterFeldbreite(von, bis)
      x + 10:     EingabeFensterWriteFeld(von, bis, x, namebrmax, vorgabe$) 
      x + namebrmax + feldbrmax + 10
  Next
  subwindowbreite = x + 10
  
  Select \progflag
    Case #menu_neu:          startinfo$ = "Daten Hinzufgen"  ;fr Neu
    Case #menu_edit:         startinfo$ = "Daten bernehmen"  ;fr ndern
    Case #menu_suchenImFeld: startinfo$ = "Suche starten"     ;fr Suchen im Feld
  EndSelect
  
  Select \progflag
   Case #menu_neu, #menu_edit: FormatIniFile(\dateiname, #read)
  EndSelect  
    
  SetGadgetText(#eingabe_links, "Lschen")
  SetGadgetText(#eingabe_start, startinfo$)

  SetActiveGadget(\eingabepbnr[1])
  SendMessage_(GadgetID(\eingabepbnr[1]), #EM_SETSEL, 0, -1)  ;markieren und Cursor ans Ende
  
  y = \subwinlastrow 

  If \progflag = #menu_suchenImFeld  ;fr Eingabe Suchen im Feld
     y - #button_abstand: CheckBoxGadget(#such_checkboxGk, 10, y, \buttonbr*3, \buttonhh, "Gro/Kleinschrift beachten")
     y - #button_abstand: CheckBoxGadget(#such_checkboxLv, 10, y, \buttonbr*3, \buttonhh, "Ausgabe in Liste")
     SetGadgetState(#such_checkboxGk, \suchgrossklein)
     SetGadgetState(#such_checkboxLv, \suchAusgabeinLv)        
     ;hier ev. Optiongadgets fr Sucharten
  EndIf 
  
  ;Resize falls ntig, \subwinbrhh ist die Standardgre von SubWindowOpen
  If subwindowbreite > \subwinbrhh            
    ResizeWindow(#sub_window, #PB_Ignore, #PB_Ignore, subwindowbreite, #PB_Ignore)
    ;;;x = subwindowbreite - \buttonbr - 11
    ;;;ResizeGadget(#eingabe_ende, x, #PB_Ignore, #PB_Ignore, #PB_Ignore)  
  EndIf
  
EndWith
    
EndProcedure

Procedure.i DatenSuchListeMem()
Protected item, j, x$

  If pv\suchAusgabeSave
     Protected anz = CountGadgetItems(#suchliste)
     ReDim pv\suchitems(anz)     
     pv\suchitems(0) = Str(anz)  
     For item = 1 To anz
       x$ = ""
       For j = 0 To pv\feldanzahl
          x$ + GetGadgetItemText(#suchliste, item - 1, j) + #LF$
       Next
       pv\suchitems(item) = x$
     Next
  EndIf
EndProcedure
 
Procedure.i DatenSuchen(abitem)
Protected ok = -1
Protected item, x$, s$, ori$

With pv.myProgrammvariablen

SetGadgetState(#main_liste,-1)

Select \suchmodus  ; \suchmodus + \suchwort wird in DatensuchenFirst() gesetzt  
   Case #menu_suchenNormal 
      For item = abitem To CountGadgetItems(#main_liste) - 1
         x$ = Datensatzholen(item)
         x$ = LCase(x$)
         s$ = LCase(\suchwort)                  
         If FindString(x$, s$, 1)
            StatusBarText(0, 2, s$ + " in " + "Satz: " + Str(item+1))
            SendMessage_(GadgetID(#main_liste),#LVM_ENSUREVISIBLE,item,1)
            SetGadgetState(#main_liste,item): SetActiveGadget(#main_liste)
            ok = item: Break    
         EndIf
      Next
      
   ;\suchsatz, \suchgrossklein + \suchAusgabeinLv wird in EingabeOk() gesetzt
      
   Case #menu_suchenImFeld 
      For item = abitem To CountGadgetItems(#main_liste) - 1
         x$ = Datensatzholen(item): ori$ = x$
         s$ = \suchsatz
         If \suchgrossklein = 0: x$ = LCase(x$): s$ = LCase(s$): EndIf
         If VergleicheSatz(x$, s$) = 1  
            If \suchAusgabeinLv  
               AddGadgetItem(#suchliste, -1, Str(item+1) + #LF$ + ori$)
               ok = item
            Else
               StatusBarText(0, 2, "Satz: " + Str(item+1))
               SendMessage_(GadgetID(#main_liste),#LVM_ENSUREVISIBLE,item,1)
               SetGadgetState(#main_liste,item): SetActiveGadget(#main_liste)
               ok = item: Break    
            EndIf
         EndIf
      Next
      If \suchAusgabeinLv
         ListeResize(#suchliste)
         ListeAutosize(#suchliste)
         DatenSuchListeMem()
      EndIf 
EndSelect

EndWith
  
ProcedureReturn ok     
EndProcedure

Procedure.i DatenSuchListe()
;Hinweis: Feldbreite wurde in Eingabefenster ermittelt/festgelegt

With pv.myProgrammvariablen

Protected z = \subwinbrhh     ;z ist SubWindowbreite/hhe
Protected hh = \subwinlastrow - \buttonhh
Protected j, item

  SubWindowOpen("Suchergebnis")
  
  ListIconGadget(#suchliste, 0, 0, z, hh, "Nr.", 40, #PB_ListIcon_GridLines|#PB_ListIcon_FullRowSelect)
  For j = 1 To \feldanzahl
    AddGadgetColumn(#suchliste, j, \feldnamen[j], 1)  ;ListeAutoSize setzt spter die Breite
  Next
  
  HideGadget(#eingabe_links, 1)  
  HideGadget(#eingabe_start, 1)  
  CheckBoxGadget(#such_checkboxMem, 10, \subwinlastrow, \buttonbr, \buttonhh, "Inhalt merken")
  SetGadgetState(#such_checkboxMem, \suchAusgabeSave)
  SetGadgetColor(#suchliste, #PB_Gadget_LineColor, \lvlinecolor1)
  
  If \suchAusgabeSave
     ;Feld suchitems() ist ab 4.5 Teil der Structur 
     For item = 1 To Val(\suchitems(0)) 
        AddGadgetItem(#suchliste, -1, \suchitems(item))
     Next
  EndIf
  
EndWith
EndProcedure

Procedure.i DatenSuchenFirst(modus)
With pv.myProgrammvariablen

If Not \feldanzahl: InfoMeldung(): ProcedureReturn: EndIf

  \suchmodus = modus
  Select modus
      Case #menu_suchenNormal
         \suchgrossklein = 0
         \suchwort = InputRequester("Suchen: enthalten im Datensatz", "Suchbegriff:", \suchwort)
         If \suchwort = "": ProcedureReturn: EndIf
         \suchitem = DatenSuchen(0)
         If \suchitem = -1: Infomeldung(1, "nix gefunden!"): EndIf  
      Case #menu_suchenImFeld
         EingabeFenster("Suchen", \suchsatz) 
         
  EndSelect

EndWith
EndProcedure

Procedure.i DatenSuchenNext()
Protected info$, antwort

With pv.myProgrammvariablen

If Not \feldanzahl: InfoMeldung(): ProcedureReturn: EndIf

weitersuchen:

  \suchitem = DatenSuchen(\suchitem + 1)
  If \suchitem = -1
     info$ = "nix mehr gefunden!" + #LF$ + #LF$ + "von Beginn an weitersuchen ?"
     antwort = Infomeldung(1, info$, #PB_MessageRequester_YesNo)
     If antwort = #PB_MessageRequester_Yes: Goto weitersuchen: EndIf
  EndIf

EndWith

EndProcedure

Procedure.i EingabeOk()
Protected j, eingabe$

With pv.myProgrammvariablen

;Eingaben auslesen
For j = 1 To \feldanzahl: eingabe$ + GetGadgetText(\eingabepbnr[j]) + #LF$: Next
    
If Len(eingabe$) > \feldanzahl  ;es gibt eine Eingabe in irgendeinem Feld
  
   Select \progflag  
      ;Suchen nach Feldern
      Case #menu_suchenImFeld
               \suchsatz = eingabe$
               \suchgrossklein = GetGadgetState(#such_checkboxGk)  ;wenn 1, Gro/Klein beachten 
               \suchAusgabeinLv = GetGadgetState(#such_checkboxLv)  ;wenn 1, Ausgabe in Liste
               ;hier ev. Abfrage fr Optiongadgets Sucharten
               \suchart = #suchart1    
               SubWindowClose()                            
               If \suchAusgabeinLv: DatenSuchListe(): EndIf      ;Suchliste erstellen
               \suchitem = DatenSuchen(0)               ;ab Satz null suche starten
               If \suchitem = -1
                  Infomeldung(1,"nix gefunden!")
               EndIf  
      ;Neu
      Case #menu_neu
               \datensatz = eingabe$
               AddGadgetItem(#main_liste, 0, #LF$ + eingabe$)  ;am Anfang einfgen
               SetGadgetState(#main_liste, 0)
               ListeAutosize(#main_liste)                   
      ;ndern
      Case #menu_edit
               RemoveGadgetItem(#main_liste,\eingabeitem)                ;entfernen
               AddGadgetItem(#main_liste, \eingabeitem, #LF$ + eingabe$) ;einfgen
               SetGadgetState(#main_liste, \eingabeitem)
               ListeAutosize(#main_liste) 
               SubWindowClose()
   EndSelect

Else  ;alle Felder sind leer
   SetActiveGadget(\eingabepbnr[1])
EndIf

EndWith  
EndProcedure

Procedure.i DatenNeu()
With pv.myProgrammvariablen
   
\eingabeitem = GetGadgetState(#main_liste)

If \eingabeitem < 0
   \eingabeitem = 0
EndIf    

\datensatz = ""
If CountGadgetItems(#main_liste)
   \datensatz = Datensatzholen(\eingabeitem)  ;als Vorgabe fr Neu
EndIf

EingabeFenster("Neu", \datensatz)

EndWith   
EndProcedure

Procedure.i DatenAendern()
With pv.myProgrammvariablen

If Not \feldanzahl: InfoMeldung(): ProcedureReturn: EndIf

\eingabeitem = GetGadgetState(#main_liste)

If \eingabeitem > -1
   \datensatz = Datensatzholen(\eingabeitem)  ;als Vorgabe fr Neu
   EingabeFenster(Str(\eingabeitem + 1) + ". Satz ndern", \datensatz)
Else
   \progflag = 0
   Infomeldung(1,"kein Eintrag markiert!") 
EndIf 

EndWith
EndProcedure

Procedure.i DatenLoeschen()

If Not pv\feldanzahl: InfoMeldung(): ProcedureReturn: EndIf

Protected j, Dim liste(0)
Protected dnr, x$

LvGetSelected(pv\mainlvid, liste())

If liste(0)
   dnr = OpenFile(#PB_Any, pv\dateiname + ".del")
   If dnr: FileSeek(dnr, Lof(dnr)): EndIf
   For j = liste(0) To 1 Step -1
      If dnr
         pv\datensatz = Datensatzholen(liste(j))
         ReplaceString(pv\datensatz, #LF$, #TAB$, #PB_String_InPlace)
         WriteStringN(dnr, pv\datensatz)   ;:Debug pv\datensatz
      EndIf
      RemoveGadgetItem(#main_liste, liste(j))
   Next
   If dnr: CloseFile(dnr): EndIf
   SetGadgetState(#main_liste, liste(1))
Else
   pv\progflag = 0
   Infomeldung(1, "kein Eintrag zum Lschen markiert!") 
EndIf 

EndProcedure

Procedure.i DatenSortierenDelArrow(spalte)
Protected hd.hd_item, j
   
#HDF_SORTDOWN = $200 
#HDF_SORTUP = $400 

With pv.myProgrammvariablen
   
For j = 1 To \feldanzahl
   If j <> spalte
      hd\mask = #HDI_FORMAT
      SendMessage_(\headerid, #HDM_GETITEM, j, @hd)
      If hd\fmt & #HDF_SORTDOWN
         hd\fmt ! #HDF_SORTDOWN
      ElseIf hd\fmt & #HDF_SORTUP
         hd\fmt ! #HDF_SORTUP
      EndIf
      SendMessage_(\headerid, #HDM_SETITEM, j, @hd)
   EndIf
Next

EndWith   
EndProcedure

Procedure.s DatenSortierenGetDate(a$)
Protected datum = ParseDate(pv\datummaske, a$)
Protected datumlen = Len(pv\datummaske)
a$ = RSet(Str(datum), datumlen, "0")    
ProcedureReturn a$   
EndProcedure

Procedure.i DatenSortierenAuswahl()
With pv.myProgrammvariablen

If Not \feldanzahl: InfoMeldung(): ProcedureReturn: EndIf

Protected x, br, ab, y, j
Protected z = \subwinbrhh     ;z ist SubWindowbreite/hhe

  SubWindowOpen("Sortieren", "Abbruch") 
  x = 10: br = (z - 20 ) / 3: ab = #button_abstand
  y = 10: TextGadget(#PB_Any, x, y, z-20, \buttonhh, "Whlen Sie die Sortierreihenfolge")
  y + ab: ListViewGadget(#sort_box1, x, y, br, 220): x + br
          ListViewGadget(#sort_box2, x, y, br, 220): x + br
          ListViewGadget(#sort_box3, x, y, br, 220)
  
  x = 10: y = \subwinlastrow - ab 
  CheckBoxGadget(#sort_gk, x, y, z - x, \buttonhh, "Gro/Kleinschrift beachten") 
  SetGadgetState(#sort_gk, \sortcasegk) 
  
  SetGadgetText(#eingabe_links, "absteigend")
  SetGadgetText(#eingabe_start, "aufsteigend Sortieren")
  
  For j = 1 To \feldanzahl
    AddGadgetItem (#sort_box1, -1, \feldnamen[j])   
    AddGadgetItem (#sort_box2, -1, \feldnamen[j])   
    AddGadgetItem (#sort_box3, -1, \feldnamen[j])   
  Next
  SetGadgetState(#sort_box1, \sortspalte[1] - 1)
  SetGadgetState(#sort_box2, \sortspalte[2] - 1)
  SetGadgetState(#sort_box3, \sortspalte[3] - 1) 

EndWith  
EndProcedure

Procedure.i DatenSortierenStart(richtung)
With pv.myProgrammvariablen

Protected sorttiefe = 25
Protected datenposi = 1 + (sorttiefe * 3)
Protected datenanzahl = CountGadgetItems(#main_liste) -1
Protected Dim daten$(datenanzahl+1)
Protected j, x$, a$, b$, c$

DatenSortierenDelArrow(-1)

\sortspalte[1] = GetGadgetState(#sort_box1) + 1    ;:Debug \sortspalte[1]
\sortspalte[2] = GetGadgetState(#sort_box2) + 1    ;:Debug \sortspalte[2]
\sortspalte[3] = GetGadgetState(#sort_box3) + 1    ;:Debug \sortspalte[3]
  
Protected spaltenname$, datumflag

For j = 1 To 3
   spaltenname$ = Trim(LCase(GetGadgetItemText(#main_liste, -1, \sortspalte[j])))
   \datespalte[j] = 0
   If FindString(spaltenname$, "datum", 1): datumflag = #True: \datespalte[j] = \sortspalte[j]: EndIf
Next

  For j = 0 To datenanzahl 
    x$ = Datensatzholen(j)
    a$ = StringField(x$, \sortspalte[1], #LF$);  :Debug a$
    b$ = StringField(x$, \sortspalte[2], #LF$);  :Debug b$
    c$ = StringField(x$, \sortspalte[3], #LF$);  :Debug c$
  
    If datumflag
       If \datespalte[1]: a$ = DatenSortierenGetDate(a$): EndIf
       If \datespalte[2]: b$ = DatenSortierenGetDate(b$): EndIf
       If \datespalte[3]: c$ = DatenSortierenGetDate(c$): EndIf
    EndIf
     
    daten$(j) = LSet(a$, sorttiefe)
    daten$(j) + LSet(b$, sorttiefe)
    daten$(j) + LSet(c$, sorttiefe) 
    daten$(j) + x$  ;:Debug daten$(j)
  Next
    
  \sortcasegk = GetGadgetState(#sort_gk)
  If \sortcasegk = #PB_Checkbox_Checked
     SortArray(daten$(), richtung, 0, datenanzahl)
  Else   
     SortArray(daten$(), richtung | #PB_Sort_NoCase, 0, datenanzahl)
  EndIf   
  
  HideGadget(#main_liste, 1): ClearGadgetItems(#main_liste) 
  For j = 0 To datenanzahl 
     x$ = #LF$ + Mid(daten$(j), datenposi)
     AddGadgetItem(#main_liste, -1, x$)
  Next
  HideGadget(#main_liste, 0)
  SubWindowClose()

EndWith
EndProcedure

Procedure.i MainListeHeaderClick()
With pv.myProgrammvariablen

Protected spalte = -1   
Protected p.POINT  
Protected HitInfo.HD_HITTESTINFO 
Protected flags, iitem

  If GetCapture_() = \headerid  
     GetCursorPos_(p) 
     MapWindowPoints_(0,\headerid,p,1) ;hwndfrom mu null sein !        
     Hitinfo\pt\x = p\x 
     HitInfo\pt\y = p\y 
     SendMessage_(\headerid,#HDM_HITTEST,0,HitInfo)        
     flags = hitinfo\flags      ;:Debug "flags " + Str(flags)
     iitem = hitinfo\iitem      ;:Debug "iitem " + Str(iitem)
     If flags = #HHT_ONHEADER
        spalte = iitem  
     ElseIf flags = #HHT_ONDIVOPEN And iitem = 0
        \headernull = 1  ;es wird versucht die Breite von Spalte 0 zu ndern
     Else
        StatusBarText(0, 2, Str(GetGadgetItemAttribute(#main_liste, 0, #PB_ListIcon_ColumnWidth, iitem)))
     EndIf               
  EndIf

EndWith
  
ProcedureReturn spalte 
EndProcedure

Procedure.i MainListeHeaderSort(spalte)
With pv.myProgrammvariablen

Protected hd.hd_item
Protected sortoption 

#HDF_SORTDOWN = $200 
#HDF_SORTUP = $400 

; alt ohne Dreiecke im Header
; hd\mask = #HDI_FORMAT
; SendMessage_(\headerid, #HDM_GETITEM, spalte, @hd)
; 
; hd\mask = #HDI_LPARAM
; SendMessage_(\headerid, #HDM_GETITEM, spalte, @hd)
;   
; If hd\lparam = spalte
;    hd\lparam = -1
;    sortoption = #PB_Sort_Ascending 
; Else
;    hd\lparam = spalte
;    sortoption = #PB_Sort_Descending
; EndIf   
; SendMessage_(\headerid, #HDM_SETITEM, spalte, @hd)

DatenSortierenDelArrow(spalte)
   
hd\mask = #HDI_FORMAT
SendMessage_(\headerid, #HDM_GETITEM, spalte, @hd)

If hd\fmt & #HDF_SORTDOWN
  hd\fmt ! #HDF_SORTDOWN
  hd\fmt | #HDF_SORTUP
  sortoption = #PB_Sort_Ascending 
ElseIf hd\fmt & #HDF_SORTUP
  hd\fmt ! #HDF_SORTUP
  hd\fmt | #HDF_SORTDOWN  
  sortoption = #PB_Sort_Descending
Else
  hd\fmt | #HDF_SORTDOWN  
  sortoption = #PB_Sort_Descending
EndIf   
SendMessage_(\headerid, #HDM_SETITEM, spalte, @hd)
SendMessage_(\headerid, #HDM_SETBITMAPMARGIN , -2, 0)

Protected sortspalte = spalte
Protected sorttiefe  = 25
Protected datenposi  = 1 + sorttiefe
Protected datenanzahl = CountGadgetItems(#main_liste) - 1
Protected Dim daten$(datenanzahl + 1)
Protected j, x$, a$

Protected datumflag
Protected spaltenname$ = Trim(LCase(GetGadgetItemText(#main_liste, -1, sortspalte)))

   If FindString(spaltenname$, "datum", 1): datumflag = #True: EndIf

   For j = 0 To datenanzahl 
      x$ = Datensatzholen(j)
      a$ = StringField(x$, sortspalte, #LF$)
      If datumflag
         a$ = DatenSortierenGetDate(a$)
      EndIf
      daten$(j) = LSet(a$, sorttiefe) + x$  ;:Debug daten$(j)  
   Next
     
   SortArray(daten$(), sortoption, 0, datenanzahl)
   
   HideGadget(#main_liste,1)
   ClearGadgetItems(#main_liste) 
   For j = 0 To datenanzahl 
      x$ = #LF$ + Mid(daten$(j), datenposi)
      AddGadgetItem(#main_liste, -1, x$)
   Next
   HideGadget(#main_liste,0)

EndWith    
EndProcedure

Procedure.i SpaltenName()
With pv.myProgrammvariablen   

Protected x, y, j, txt$
Protected z = \subwinbrhh     ;z ist SubWindowbreite/hhe

If Not \feldanzahl: InfoMeldung(): ProcedureReturn: EndIf
   
   Select \progflag
    Case #menu_spaltenName: txt$ = "Spaltenname ndern"
    Case #menu_spalteEntfernen: txt$ = "Spalte entfernen"
    Case #menu_spalteAnhaengen: txt$ = "Spalte anhngen"
   EndSelect
   
   SubWindowOpen(txt$)   
   
   HideGadget(#eingabe_links, 1) 
   DisableGadget(#eingabe_start, 1) 
   SetGadgetText(#eingabe_start, txt$)   

   x = 200
   y = 10: ListViewGadget(#spalte_listbox, 10, y, 170, z-50)
   y + 30: StringGadget  (#spalte_nameEingabe, x, y, \buttonbr, \buttonhh, "")        
   y + 30: TextGadget    (#spalte_infotext, x, y, z - x - 20, z - y - 40, "")
   
   If \progflag = #menu_spalteEntfernen   ;Eingabefeld nicht ntig
      HideGadget (#spalte_nameEingabe, 1)
   EndIf
   
   For j = 1 To \feldanzahl: AddGadgetItem(#spalte_listbox, -1, \feldnamen[j]): Next
   
EndWith
  
EndProcedure

Procedure.i Daten_Events(wB)
Protected j, welchesActiveGadget
Protected fbitem, name$, text$, menu$, antwort
Static point.Point

With pv.myProgrammvariablen   

Select wB   ;wB wird \progflag
                       
   ;Menupunkte Bearbeiten, Suchen, Sortieren, Spalten
   Case #menu_neu
      \progflag = wB: DatenNeu()

   Case #menu_edit
      \progflag = wB: DatenAendern()    
                     
   Case #menu_kill
      \progflag = wB: DatenLoeschen()
   
   Case #menu_suchenNormal, #menu_suchenImFeld
      \progflag = wB: DatensuchenFirst(wB) 
            
   Case #menu_suchenWeiter
      \suchAusgabeinLv = 0: DatensuchenNext()
   
   Case #menu_sortieren
      \progflag = wB: Datensortierenauswahl()
   
   Case #menu_spaltenName, #menu_spalteEntfernen, #menu_spalteAnhaengen
      \progflag = wB: SpaltenName()   

   Case #menu_spaltenInfo: StatusBarText(0, 0, GetOrderArray())
      
   Case #menu_divDateGadget: HideWindow(#calendar_window, 0): StickyWindow(#calendar_window, 1) 
                             ;oder RunProgram("control", "timedate.cpl", "")
                             
   Case #menu_divSumme: FormatSumme()
      
   Case #menu_divNotepadFmt: FormatNotepad(\feldformatdatei)
   Case #menu_divNotepadPop: FormatNotepad(\feldpopupdatei)
                             FormatPopUpSort()
      
   ;Gadgets etc ----------------------------------------------------------
   
   Case #calendar_button: HideWindow(#calendar_window, 1): StickyWindow(#calendar_window, 0) 
      
   Case #main_liste 
      Select EventType()  
         Case #PB_EventType_LeftClick, 768
            StatusBarText(0, 1, Str(1+GetGadgetState(#main_liste)))
         Case #PB_EventType_LeftDoubleClick
            pv\progflag = #menu_edit
            DatenAendern()
      
         Case #PB_EventType_RightClick
            LvGetMausclick(GadgetID(#main_liste), point)
            FormatPopUpGetMenu(point, WindowID(#main_window))            
      EndSelect   
   
   ;SpaltenPopUp siehe auch FormatPopUp...() in MiniAdr-Format.pbi
   Case 1000 To 1100
      
      menu$ = FormatPopUpGetString(wB)  

      If GetActiveGadget() = #main_liste 
         ;benutzt point von #PB_EventType_RightClick der #main_liste
         text$ = GetGadgetItemText(#main_liste, point\y, point\x) + " " + menu$
         text$ = LTrim(text$)
         SetGadgetItemText(#main_liste, point\y, text$, point\x) 
      Else
         ;Feldeingabe
         FormatPopUpInsertString(menu$)
      EndIf
      
   ;Taste Return gedrckt im SubWindow mit Feldeingaben
   Case #eingabe_Return 
      j = GetFeldEingabeIndex(GetActiveGadget())
      If j
         ;Markierung aufheben
         SendMessage_(GadgetID(\eingabepbnr[j]), #EM_SETSEL, 0, 0) 
         j + 1: If j > \feldanzahl: j = 1: EndIf  
         SetActiveGadget(\eingabepbnr[j])
         ;markieren + ans Ende
         SendMessage_(GadgetID(\eingabepbnr[j]), #EM_SETSEL, 0, -1) 
      EndIf      
                  
   ;Stringgadget in der Eingabemaske, welches Feld wurde verlassen
   Case \eingabepbnr[1] To \eingabepbnr[\feldanzahl]
      If \formatflag
         If EventType() = #PB_EventType_LostFocus
            j = GetFeldEingabeIndex(wB) 
            If j: Format_1(j): EndIf
         EndIf
      EndIf
      
   ;gedrckt im SubWindow Suchliste 
   Case #such_checkboxMem 
      \suchAusgabeSave = GetGadgetState(#such_checkboxMem)  ;Checkbox Inhalt merken
      If \suchAusgabeSave: DatenSuchListeMem(): EndIf

   ;gedrckt im SubWindow Spalten
   Case #spalte_listbox 
      ;Hinweis: in der Listbox wird ab null gezhlt
      ;der oberste Spaltename ist also item 0
      ;hingegen die Feldnamen bzw. die Spaltennamen der main_liste
      ;beginnen bei 1, denn Spalte null wird nicht benutzt !
      
      fbitem = GetGadgetState(#spalte_listbox)  ;wer ist markiert ab 0 ? 
      If fbitem > -1
         name$ = GetGadgetItemText(#spalte_listbox, fbitem)
         SetGadgetText(#spalte_nameEingabe, name$)
         DisableGadget(#eingabe_start, 0)
         DisableGadget(#spalte_nameEingabe,0)
      EndIf
      
   Case #spalte_nameEingabe
      If EventType() = #PB_EventType_Change 
         DisableGadget(#eingabe_start, 0)
      EndIf   
      
   ;Buttons gedrckt im SubWindow
   Case #eingabe_links 
      Select \progflag
         Case #menu_neu, #menu_edit, #menu_suchenImFeld
            For j = 1 To \feldanzahl
               SetGadgetText(\eingabepbnr[j], "")
            Next
            SetActiveGadget(\eingabepbnr[1])
         Case #menu_sortieren
            DatensortierenStart(#PB_Sort_Descending)   ;absteigend 
      EndSelect

   Case #eingabe_start  
      
      ;Funktion je nach Menupunkt ausfhren
      Select \progflag
         
         Case #menu_neu, #menu_edit, #menu_suchenImFeld
            EingabeOk()
            
         Case #menu_sortieren
            DatensortierenStart(#PB_Sort_Ascending)   ;aufsteigend 
         
         Case #menu_spaltenName
            fbitem = GetGadgetState(#spalte_listbox)  ;wer ist markiert ab 0 ? 
            name$ = Trim(GetGadgetText(#spalte_nameEingabe))
            If SpaltenNameOk(#spalte_listbox,name$)
              SetGadgetItemText(#spalte_listbox, fbitem, name$)
              SetGadgetState(#spalte_listbox, fbitem)
              SetGadgetItemText(#main_liste, -1, name$, fbitem + 1)
              pv\feldnamen[fbitem + 1] = name$
              ListeAutosize(#main_liste)
            EndIf
         
         Case #menu_spalteEntfernen
            fbitem = GetGadgetState(#spalte_listbox)  ;wer ist markiert ab 0 ? 
            If fbitem > -1
               name$ = " [" + GetGadgetItemText(#spalte_listbox, fbitem) + "] "
               text$ = "Wollen Sie die Spalte" + name$ + "wirklich lschen ?"
               antwort = Infomeldung(3, text$, #PB_MessageRequester_YesNo)
               If antwort = #PB_MessageRequester_Yes
                  fbitem + 1  
                  HideGadget(#main_liste,1)
                  RemoveGadgetColumn(#main_liste, fbitem)
                  ListeAutosize(#main_liste) 
                  ClearGadgetItems(#spalte_listbox)
                  pv\feldanzahl - 1
                  For j = 1 To pv\feldanzahl
                     pv\feldnamen[j] = GetGadgetItemText(#main_liste, -1, j)
                     AddGadgetItem(#spalte_listbox, -1, pv\feldnamen[j])
                  Next
                  text$ = "die Spalte" + name$ + "wurde entfernt" + #LF$ + #LF$
                  text$ + "Entgltig gelscht wird diese Spalte" + #LF$
                  text$ + "wenn die Daten gespeichert werden !"
                  SetGadgetText(#spalte_infotext, text$)
               EndIf
            EndIf   
         
         Case #menu_spalteAnhaengen
            name$ = Trim(GetGadgetText(#spalte_nameEingabe))
            If name$ 
               pv\feldanzahl + 1
               If pv\feldanzahl > #maxfelder
                  pv\feldanzahl - 1
                  Infomeldung(4,"mehr als "+Str(#maxfelder)+" Felder geht nicht")
               Else  
                  If Not SpaltenNameOk(#spalte_listbox, name$)
                     name$ + "1"                  
                  EndIf
                  AddGadgetItem(#spalte_listbox, -1, name$)
                  HideGadget(#main_liste, 1)
                  AddGadgetColumn(#main_liste, pv\feldanzahl, name$, 1)
                  pv\feldnamen[pv\feldanzahl] = name$
                  ListeAutosize(#main_liste)  
                  text$ = "die Spalte [ " + name$ + " ] wurde angehngt" + #LF$ + #LF$
                  text$ + "Sie knnen die Spalte nun mit der Maus verschieben !"+ #LF$ + #LF$
                  text$ + "Entgltig Teil der Datei wird die Spalte" + #LF$
                  text$ + "wenn die Daten gespeichert werden !" 
                  SetGadgetText(#spalte_infotext, text$)
              EndIf 
            EndIf        
            
         EndSelect  

   Case #eingabe_ende: SubWindowClose()              

EndSelect

EndWith
EndProcedure

Procedure.i WM_events(event)
Protected point.Point, j
Static spalte 

Select event
   ;fr Popup EingabeStringgadgets !!!
   Case #WM_RBUTTONDOWN
      j = GetFeldEingabeIndex(GetActiveGadget())  
      If j 
         point\x = j
         FormatPopUpGetMenu(point, WindowID(#sub_window)) 
      EndIf
     
   ;fr Mainliste per Headerclick sortieren         
   Case #WM_LBUTTONDOWN ;linke Maustaste gedrckt
      ;Rckgabe ist -1 oder Spaltennr. ab 1. Spalte null wird nicht benutzt.
      spalte = MainListeHeaderClick() 
      
   Case #WM_MOUSEMOVE ;wenn zwischen #WM_LBUTTONDOWN + #WM_LBUTTONUP ein move,      
      spalte = -1     ;dann Aktion = Drag/Drop oder Breite ndern
      
   Case #WM_LBUTTONUP   ;nur wenn zwischen down + up kein move, dann sortieren
      If spalte > -1
         MainListeHeaderSort(spalte)
      ElseIf pv\headernull   ;wird in MainListeHeaderClick() ev. gesetzt
         pv\headernull = 0
         SetGadgetItemAttribute(#main_liste, 0, #PB_ListIcon_ColumnWidth, 0, 0)
      EndIf   
       
EndSelect

EndProcedure

; IDE Options = PureBasic 4.50 RC 2 (Windows - x86)
; CursorPosition = 664
; FirstLine = 531
; Folding = +-7+
; Markers = 561
; EnableXP